//////// methodes.sci: //////////
// exec methodes.sci

function [Q,R,err]=QR(A)

[n,m]=size(A);
AA=A;

u=householder(A(:,1));
H1=eye()-2*u*u';
Q=H1;
A=H1*A;


for j=2:m

u=householder(A(j:$,j));
H1=eye()-2*u*u';
H1=sysdiag(eye(j-1,j-1),H1);
Q=H1*Q;
A=H1*A;

end

Q=Q';
R=A;
err=norm(Q*R-AA);
err=err+norm(R-triu(R));
err=err+norm(Q'*Q-eye());


endfunction

function Z=orthonorm(Y)

Z=[];

[n,m]=size(Y);

u=Y(:,1);
u=u/norm(u);
Z=[u];
for j=2:m
u=Y(:,j);
u=u-Z*Z'*u;
u=u/norm(u);
Z=[Z,u];
end

endfunction


function [x,nu]=puissance(A,N)

x=2*rand(A(:,1))-ones();
for k=1:N
   y=A*x;
   nu=x'*y;
   x=y/norm(y);
end

endfunction

function [x,nu]=puissance_m(A,N)

x=2*rand(A)-ones();
for k=1:N
   y=A*x;
   nu=x'*y;
   x=orthonorm(y);
end
endfunction


function [Q,R,taberr]=QRval(A,iter)

A0=A;
Q=eye(A);
taberr=[];

for k=1:iter
[Qk,Rk]=QR(A0);
A1=Rk*Qk;
A0=A1;
Q=Q*Qk;

err=norm(A1-triu(A1));
taberr=[taberr,err];
end
R=A1;

endfunction

function [Q,R,taberr,iter,err]=QRval_eps(A,eps)

A0=A;
Q=eye(A);
taberr=[];

iter=0;
test=1;
itmax=100;


while (test>eps)&(iter<itmax)

//for k=1:iter
[Qk,Rk]=QR(A0);
A1=Rk*Qk;
A0=A1;
Q=Q*Qk;

err=norm(A1-triu(A1));
taberr=[taberr,err];
test=err;
iter=iter+1;
end
R=A1;

endfunction



